<div class="jgrapes-osgi-services-view"
  data-jgwc-on-load="orgJGrapesOsgiConletServices.initView"
  data-jgwc-on-unload="JGConsole.jgwc.unmountVueApps"> 
  <div class="jgrapes-osgi-services-view-search">
    <form>
      <label class="form__label--horizontal">
        <span>{{ localize("Filter") }}</span>
        <input type="search" v-on:input="controller.updateFilter($event)">
        <span role="button" tabindex="0" class="fas fa-backspace" 
          v-on:click="controller.clearFilter($event)"></span>
      </label>
    </form>
  </div>
  <table 
    class="table--basic--striped jgrapes-osgi-services-view-table">
    <thead>
      <tr>
        <th v-for="key in controller.keys"
          v-on:click="controller.sortBy(key)">
          {{ localize(controller.label(key)) }}<span v-if="controller.sortedByAsc(key)"
            role="button" tabindex="0">&#x25B2;</span><span
            v-if="controller.sortedByDesc(key)"
            role="button" tabindex="0">&#x25BC;</span>
        </th>
      </tr>
    </thead>
    <tbody>
      <template v-for="(entry, rowIndex) in filteredData">
        <tr :class="[(rowIndex % 2) ? 'odd' : 'even']">
          <td v-for="key in controller.keys"
            :rowspan="key !== 'id' ? false 
                : ($aash.isDisclosed(scopedId(rowIndex)) ? 2 : 1)">
            <aash-disclosure-button v-if="key == 'id'" :type="'div'"
              :id-ref="scopedId(rowIndex)">
              <span v-html="controller.breakBeforeDots(entry[key])"></span>
            </aash-disclosure-button>
            <span v-else
              v-html="controller.breakBeforeDots(entry[key])"></span>
          </td>
        </tr>
        <tr :id="scopedId(rowIndex)" v-if="$aash.isDisclosed(scopedId(rowIndex))"
          :class="[(rowIndex % 2) ? 'odd' : 'even']">
          <td colspan="4" class="details">
            <table class="table--basic table--basic--autoStriped">
              <tr v-for="[key, value] of sortedProperties(entry.properties)">
                <td>{{ key }}</td>
                <td>{{ value }}</td>
              </tr>
              <tr v-if="entry.usingBundles && entry.usingBundles.length > 0">
                <td>{{ localize("serviceUsingBundles") }}</td>
                <td v-html="entry.usingBundles.join(',<br>')"></td>
              </tr>
            </table>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</div>
